Bug 1105015 - Review Request: lua-ldap - LDAP client library for Lua
Summary: Review Request: lua-ldap - LDAP client library for Lua
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jeff Backus
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-06-05 08:32 UTC by Dan Callaghan
Modified: 2014-08-07 15:30 UTC (History)
2 users (show)

Fixed In Version: lua-ldap-1.1.0-3.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-08-07 15:29:16 UTC
Type: ---
jeff.backus: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Dan Callaghan 2014-06-05 08:32:45 UTC
Spec URL: http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap.spec
SRPM URL: http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap-1.1.0-1.fc20.src.rpm
Description: LuaLDAP is a simple interface from Lua to an LDAP client. It enables a Lua program to:
* Connect to an LDAP server;
* Execute any operation (search, add, compare, delete, modify and rename);
* Retrieve entries and references of the search result.
Fedora Account System Username: dcallagh

Comment 1 Jeff Backus 2014-06-22 13:50:57 UTC
Hi Dan,

I reviewed your package and had a few minor points (also noted inline in the review):
* Have you queried upstream re: including the MIT license text in source tarball?
* Please work with upstream (or create a patch) to change the following line in the Makefile:
    cp src/$(LIBNAME) $(LUA_LIBDIR)
  to:
    cp -p src/$(LIBNAME) $(LUA_LIBDIR)

Otherwise it looks fine to me.

Also, this is my first review as a packager, so if I didn't set something right in the bug, please let me know.

Regards,
Jeff

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
     As this is a library, .so files are expected.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 3 files have unknown license. Detailed output of
     licensecheck in /mnt/storage/backed_up/home/jeff/tmp/reviews/1105015-lua-
     ldap/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
     README indicates license is "same as Lua 5.1", which is released under MIT.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
     Have you queried upstream re: including the MIT license text in source tarball?
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in lua-ldap-
     compat
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
     Source tarball contains what looks like some sort of test. Maybe add as %check?
[!]: Packages should try to preserve timestamps of original installed files.
     Please work with upstream (or create a patch) to change the following line in the Makefile:
        cp src/$(LIBNAME) $(LUA_LIBDIR)
     to:
	cp -p src/$(LIBNAME) $(LUA_LIBDIR)
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: lua-ldap-1.1.0-1.fc20.x86_64.rpm
          lua-ldap-compat-1.1.0-1.fc20.x86_64.rpm
          lua-ldap-1.1.0-1.fc20.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint lua-ldap lua-ldap-compat
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
lua-ldap (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libldap-2.4.so.2()(64bit)
    lua(abi)
    rtld(GNU_HASH)

lua-ldap-compat (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libldap-2.4.so.2()(64bit)
    lua(abi)
    rtld(GNU_HASH)



Provides
--------
lua-ldap:
    lua-ldap
    lua-ldap(x86-64)

lua-ldap-compat:
    lua-ldap-compat
    lua-ldap-compat(x86-64)



Unversioned so-files
--------------------
lua-ldap: /usr/lib64/lua/5.2/lualdap.so
lua-ldap-compat: /usr/lib64/lua/5.1/lualdap.so

Source checksums
----------------
http://files.luaforge.net/releases/lualdap/lualdap/LuaLDAP1.1.0/lualdap-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : c2875704b8cdc6398c2f1cf25199a16d217ded2c696d134ae591935ab3c98d33
  CHECKSUM(SHA256) upstream package : c2875704b8cdc6398c2f1cf25199a16d217ded2c696d134ae591935ab3c98d33


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1105015
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 Dan Callaghan 2014-06-30 01:48:09 UTC
(In reply to Jeff Backus from comment #1)
> [!]: If the source package does not include license text(s) as a separate
> file
>      from upstream, the packager SHOULD query upstream to include it.
>      Have you queried upstream re: including the MIT license text in source
> tarball?

The license is in the tarball as doc/us/license.html (easily missed since it's not included as plain text in the root, like most packages).

It's in the corresponding place under /usr/share/doc for the lua-ldap and lua-ldap-compat packages as well.

> [-]: %check is present and all tests pass.
>      Source tarball contains what looks like some sort of test. Maybe add as
> %check?

I wrote a little script to allow running the tests against a dummy slapd in %check.

https://github.com/luaforge/lualdap/pull/2

> [!]: Packages should try to preserve timestamps of original installed files.
>      Please work with upstream (or create a patch) to change the following
> line in the Makefile:
>         cp src/$(LIBNAME) $(LUA_LIBDIR)
>      to:
> 	cp -p src/$(LIBNAME) $(LUA_LIBDIR)

Preserving timestamps in this case doesn't serve much purpose, since the file is built right before that and is not included in multiple subpackages or anything like that. However I can easily add it.

http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap.spec
http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap-1.1.0-2.fc21.src.rpm

Comment 3 Jeff Backus 2014-07-01 22:37:05 UTC
(In reply to Dan Callaghan from comment #2)
> 
> The license is in the tarball as doc/us/license.html (easily missed since
> it's not included as plain text in the root, like most packages).
> 
> It's in the corresponding place under /usr/share/doc for the lua-ldap and
> lua-ldap-compat packages as well.
> 

Found it. Thanks!

> > [-]: %check is present and all tests pass.
> >      Source tarball contains what looks like some sort of test. Maybe add as
> > %check?
> 
> I wrote a little script to allow running the tests against a dummy slapd in
> %check.
> 
> https://github.com/luaforge/lualdap/pull/2

Looks good. Thanks!

> 
> > [!]: Packages should try to preserve timestamps of original installed files.
> >      Please work with upstream (or create a patch) to change the following
> > line in the Makefile:
> >         cp src/$(LIBNAME) $(LUA_LIBDIR)
> >      to:
> > 	cp -p src/$(LIBNAME) $(LUA_LIBDIR)
> 
> Preserving timestamps in this case doesn't serve much purpose, since the
> file is built right before that and is not included in multiple subpackages
> or anything like that. However I can easily add it.
> 

Good point. Also, unfortunately, I seem to have given you erroneous advice. cp -p copies all permissions, so now I'm getting a rpmlint error. The correct method is to use install -p. I verified that this is correct. Please change destdir.patch to either use install -p or to not use cp -p on line 12. Sorry about that!

> http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap.spec
> http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap-1.1.0-2.fc21.src.rpm

Since this package hasn't been built by the system, increasing the version number is optional. Please see the section on multiple Changelog Entries per Release in the guidelines for more information. 
https://fedoraproject.org/wiki/Packaging:Guidelines#Multiple_Changelog_Entries_per_Release

So, in summary, please fix the previous "fix" I requested ('cp -p' -> 'install -p' or just 'cp'). Otherwise, the package looks good!

Regards,
Jeff

Comment 4 Dan Callaghan 2014-07-13 10:30:37 UTC
(In reply to Jeff Backus from comment #3)
> Good point. Also, unfortunately, I seem to have given you erroneous advice.
> cp -p copies all permissions, so now I'm getting a rpmlint error. The
> correct method is to use install -p. I verified that this is correct. Please
> change destdir.patch to either use install -p or to not use cp -p on line
> 12. Sorry about that!

Oops. Fixed:

http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap.spec
http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap-1.1.0-3.fc22.src.rpm

> Since this package hasn't been built by the system, increasing the version
> number is optional. Please see the section on multiple Changelog Entries per
> Release in the guidelines for more information. 
> https://fedoraproject.org/wiki/Packaging:
> Guidelines#Multiple_Changelog_Entries_per_Release

I prefer to bump the RPM release number each time I publish a new SRPM on the review, even though it's not built in Koji yet. It makes it possible for someone who comes along and looks at the review after the fact to fetch each different version of the SRPM and see what changed each time.

Comment 5 Jeff Backus 2014-07-19 00:32:17 UTC
(In reply to Dan Callaghan from comment #4)
> Oops. Fixed:
> 
> http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap.spec
> http://fedorapeople.org/~dcallagh/lua-ldap/lua-ldap-1.1.0-3.fc22.src.rpm
> 

Looks good! Thanks!

> I prefer to bump the RPM release number each time I publish a new SRPM on
> the review, even though it's not built in Koji yet. It makes it possible for
> someone who comes along and looks at the review after the fact to fetch each
> different version of the SRPM and see what changed each time.

Yeah, that's probably the better way to do it. :)

Here's a final review pass. I did not see any problems. Package is APPROVED.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
     
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 4 files have unknown license. Detailed output of
     licensecheck in /mnt/storage/backed_up/homes/jeff/tmp/reviews/lua-ldap
     /review-lua-ldap/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
     License file included.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in lua-ldap-
     compat
     Package is noarch.
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: lua-ldap-1.1.0-3.fc20.i686.rpm
          lua-ldap-compat-1.1.0-3.fc20.i686.rpm
          lua-ldap-1.1.0-3.fc20.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint lua-ldap lua-ldap-compat
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
lua-ldap (rpmlib, GLIBC filtered):
    libc.so.6
    libldap-2.4.so.2
    lua(abi)
    rtld(GNU_HASH)

lua-ldap-compat (rpmlib, GLIBC filtered):
    libc.so.6
    libldap-2.4.so.2
    lua(abi)
    rtld(GNU_HASH)



Provides
--------
lua-ldap:
    lua-ldap
    lua-ldap(x86-32)

lua-ldap-compat:
    lua-ldap-compat
    lua-ldap-compat(x86-32)



Unversioned so-files
--------------------
lua-ldap: /usr/lib/lua/5.2/lualdap.so
lua-ldap-compat: /usr/lib/lua/5.1/lualdap.so

Source checksums
----------------
http://files.luaforge.net/releases/lualdap/lualdap/LuaLDAP1.1.0/lualdap-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : c2875704b8cdc6398c2f1cf25199a16d217ded2c696d134ae591935ab3c98d33
  CHECKSUM(SHA256) upstream package : c2875704b8cdc6398c2f1cf25199a16d217ded2c696d134ae591935ab3c98d33


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/bin/fedora-review -n lua-ldap
Buildroot used: fedora-20-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 6 Dan Callaghan 2014-07-20 22:03:10 UTC
Thanks Jeff!

New Package SCM Request
=======================
Package Name: lua-ldap
Short Description: LDAP client library for Lua
Upstream URL: http://www.keplerproject.org/lualdap/
Owners: dcallagh
Branches: f19 f20 f21 el6 epel7
InitialCC:

Comment 7 Gwyn Ciesla 2014-07-21 12:45:16 UTC
Git done (by process-git-requests).

Comment 8 Fedora Update System 2014-07-22 00:00:47 UTC
lua-ldap-1.1.0-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lua-ldap-1.1.0-3.fc20

Comment 9 Fedora Update System 2014-07-22 00:01:25 UTC
lua-ldap-1.1.0-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/lua-ldap-1.1.0-3.fc19

Comment 10 Fedora Update System 2014-07-22 00:02:02 UTC
lua-ldap-1.1.0-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/lua-ldap-1.1.0-3.el6

Comment 11 Fedora Update System 2014-07-23 03:00:21 UTC
lua-ldap-1.1.0-3.fc20 has been pushed to the Fedora 20 testing repository.

Comment 12 Fedora Update System 2014-08-07 11:49:16 UTC
lua-ldap-1.1.0-3.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 13 Fedora Update System 2014-08-07 15:29:16 UTC
lua-ldap-1.1.0-3.fc20 has been pushed to the Fedora 20 stable repository.

Comment 14 Fedora Update System 2014-08-07 15:30:17 UTC
lua-ldap-1.1.0-3.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.